<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class User
{
	/**
    * array of all user infos
    * @access Public
    * @var array()
    */
	var $info_user;
	
	/**
    * db class
    * @access Private
    * @var class
    */
	var $db;
	
	/**
    * lang class
    * @access Private
    * @var class
    */
	var $lang;
	
	/**
    * error class
    * @access Private
    * @var class
    */
	var $error;
	
	/**
    * skin class
    * @access Private
    * @var class
    */
	var $skin;
	
	/**
    * Core configs
    * @access Private
    * @var array()
    */
	var $_config;
	
	/**
    * User Constructor
    *
    * @param class db, class skin, class lang, array config, class error
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */

	function User(& $db, & $skin, & $lang, & $config, & $error, & $cache)
	{
		$this->db= & $db;
		$this->skin= & $skin;
		$this->lang= & $lang;
		$this->error= & $error;
		$this->_config= & $config;
		$this->cache = & $cache;
		header("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
		header("Last-Modified: ".date("D, d M Y H:i:s")." GMT");
		header("Cache-Control: post-check=0, pre-check=0",false);
		session_cache_limiter("must-revalidate");
		
		session_start();
		
		$sid = session_id();
		
		if(!$_SESSION['auth'] && isset($_COOKIE['revokebb_user']))
		{
			
			$temp_name = explode('%%',$_COOKIE['revokebb_user']);
			
			$temp_name[0] = base64_decode($temp_name[0]);
			
			$query = $this->db->execQuery( $this->db->sql_build('cookie_user_exists', array($temp_name[0], $temp_name[1] ) ));
			
			if($this->db->num_rows($query)==1)
			{
				$temp=$this->db->fetch_array($query);
				
				$this->login($temp_name[0], $temp_name[1], $sid, false, 0);
			}
			else
				setcookie('revokebb_user', '', time() - 3600);
		}
			
			
		$timenow = time();
		$time = $timenow-900;
		$query = $this->db->execQuery( $this->db->sql_build('session_timeout', array($time, $sid, $_SERVER['REMOTE_ADDR']) ) );

		if(isset($_SESSION['auth']) && $_SESSION['auth']==true)
		{
			$this->info_user = $this->get_infos($_SESSION['id']);
			
			$this->info_user['lastvisit'] =  gmdate('d F Y H:i', $_SESSION['lastaction']);
			
			
			$query = $this->db->execQuery( $this->db->sql_build('insert_user_session', array($this->info_user['user_nick'], $sid, $_SERVER['REMOTE_ADDR'], $this->info_user['level'], $timenow, '0' ) ) );
		}
		else
		{
		$info_spider=$this->is_spider($_SERVER['HTTP_USER_AGENT']);
			if ($info_spider!='') 
			{
    			$this->info_user=$this->get_infos(-1);
				$_SESSION['auth']=false;
				$_SESSION['username'] = $info_spider;
				$_SESSION['id'] = $this->info_user['user_id'];
				$_SESSION['signature'] = '';
				$_SESSION['avatar'] = '';
				$_SESSION['level'] = 0;
				$_SESSION['modcp']=false;
				$query = $this->db->execQuery( $this->db->sql_build('insert_user_session', array('Guest', $sid, $_SERVER['REMOTE_ADDR'], 0, $timenow, $info_spider  ) ) );
				$this->db->execQuery( $this->db->sql_build('insert_spider_log', array($info_spider, $_SERVER['REMOTE_ADDR'], $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'], $timenow) ) );
			}
			else
			{
				$this->info_user=$this->get_infos(-1);
				$_SESSION['auth']=false;
				$_SESSION['username'] = $this->info_user['user_nick'];
				$_SESSION['id'] = $this->info_user['user_id'];
				$_SESSION['signature'] = $this->info_user['user_sign'];
				$_SESSION['avatar'] = $this->info_user['user_avatar'];
				$_SESSION['level'] = $this->info_user['level'];
				$_SESSION['modcp']=false;
				
				$this->info_user['timenow'] =  gmdate('d F Y H:i', $timenow);
				
				$query = $this->db->execQuery( $this->db->sql_build('insert_user_session', array('Guest', $sid, $_SERVER['REMOTE_ADDR'], 0, $timenow, '0' ) ) );
			}
		}
		
		if($this->info_user['status'] == 0)
			$this->info_user['level'] = 0;

	}

	/**
    * get user infos
    *
    * @param int id
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */
	function get_infos($id)
	{
		if($id == -1)
			$vett = $this->cache->GetFromCache('sql_user-0', 0, true);
		else
			$vett = false;
		
		if($vett)
			return $vett;
		
		$query = $this->db->execQuery( $this->db->sql_build('fetch_user_infos_by_id', $id) );
		
		if($id == -1)
		{
			$temp = $this->db->fetch_array($query);
			$this->cache->WriteToCache('sql_user-0', $temp);
			return $temp;
		}
		
		return $this->db->fetch_array($query);
	}

	/**
    * Tell if an user exists
    *
    * @param int $id
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */
	function user_exists($id)
	{
		$query = $this->db->execQuery( $this->db->sql_build('userid_exists', $id) );
		
		return ($this->db->num_rows($query)==1);
	}
	
	/**
    * Tell if an username exists
    *
    * @param String $username
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */
	function username_exists($username)
		{
		$query = $this->db->execQuery( $this->db->sql_build('username_exists', $username) );
		
		return ($this->db->num_rows($query)==1);
		}

	/**
    * Update an user password
    *
    * @param int id, String newpassword
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */
	function update_password($id, $newpassword)
		{
		$infos=$this->get_infos($id);
		$newpassword=md5($password.'revoke4gurus');
		$query = $this->db->execQuery( $this->db->sql_build('update_user_password', array($newpassword, $id) ) );
		if($query)
			return true;
		else
			{
			//errors->general_mysql_error($db->error_num);
			return false;
			}
		}

	/**
    * Create a new user
    *
    * @param array member, String error_string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function new_user($member, & $error_string)
	{

		if($this->username_exists($member[0]))
			$this->error->simple_error('user_exists');


		$query = $this->db->execQuery( $this->db->sql_build('insert_user_all', $member) );
		
		$id = $this->db->insert_id();
		
		
		$query = $this->db->execQuery($this->db->sql_build('update_config_last_userid', $id ));
		$query = $this->db->execQuery($this->db->sql_build('update_config_last_user', $member[0] ));
		$query = $this->db->execQuery($this->db->sql_build('update_config_board_users', ($this->_config['board_users']+1) ));
		
		$this->send_activation_email($id);
	}

	/**
    * Log on an user
    *
    * @param String username, String password, bool admin
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function login($username, $password, $sid, $admin, $complete=1)
	{
		if($_SESSION['login_try'] > 4)
			$this->error->login_error('no_bruteforce');
		
		$username = htmlspecialchars($username, ENT_QUOTES);
		$password = htmlspecialchars($password, ENT_QUOTES);
		
		if($complete==1)
			$password = md5($password.'revoke4gurus');
		
		$logcheck = $this->db->execQuery( $this->db->sql_build('login_check', array( $username, $password) ) ); 
		$rows = $this->db->num_rows($logcheck);
		if($rows!=1)
		{
			if(!isset($_SESSION['login_try']) || $_SESSION['login_username'] != $username)
			{
				$_SESSION['login_try'] = 1;
				$_SESSION['login_username'] = $username;
			}
			else
				$_SESSION['login_try'] ++;
			
			if($admin == true)
			{
				header('location: '.$this->_config['board_domain'].$this->_config['board_url'].'index.php?act=admin&error=1');	
				exit;
			}
			else
				$this->error->login_error('no_login');
		}
		
		$loadlevel = $this->db->fetch_array($logcheck);
		
		if($admin==true && $loadlevel['level']<7)
			$this->error->simple_error('no_perm');
		
		if($admin==true)
		{
			if($this->info_user['admincp']!=1)
				$this->error->simple_error('no_perm');
				
			$_SESSION['admin'] = true;
			$url = 'index.php?act=admin';
		}
		else
		{
			$_SESSION['admin'] = false;
			$url = htmlentities($_POST['referer']);
			
			if(strlen($url)<5)
				$url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'];
			
			if(strstr($url, 'act=login'))
				$url = str_replace('act=login', 'act=index', $url);
		}
		
	
		$_SESSION['auth'] = true;
		$_SESSION['username'] = $loadlevel['user_nick'];
		$_SESSION['id'] = $loadlevel['user_id'];
		$_SESSION['signature'] = $loadlevel['user_sign'];
		$_SESSION['avatar'] = $loadlevel['user_avatar'];
		$_SESSION['level'] = $loadlevel['level'];
		$_SESSION['modcp'] = false;
		$_SESSION['lastaction'] = $loadlevel['lastaction'];
		
		$timenow = time();
		
		$query = $this->db->execQuery( $this->db->sql_build('update_user_lastaction', array($timenow, $loadlevel['user_id']) ) );

		if($complete==1)
		{
			if($_POST['remember'] == 1)
				setcookie('revokebb_user', base64_encode($loadlevel['user_nick']).'%%'.$loadlevel['user_password'], $timenow+2592000, $this->_config['board_url']);
			
			$this->lang->load('login');
			
			$this->error->complete($url, $this->lang->language['login_done'].$loadlevel['user_nick']);
			exit;
		}
	}
	

	/**
    * Log out an user
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function logout()
	{
		$sid=session_id();
		unset($_SESSION['auth']);
		unset($_SESSION['username']);
		unset($_SESSION['id']);
		unset($_SESSION['signature']);
		unset($_SESSION['avatar']);
		unset($_SESSION['level']);
		unset($_SESSION['modcp']);
		unset($_SESSION['lastaction']);
		
		//cancel cookies
		setcookie('revokebb_user', '', time() - 3600);
	
		$_SESSION=array();
		session_destroy();

		$query = $this->db->execQuery( $this->db->sql_build('sid_delete', $sid ) );
		
		$this->lang->load('login');
		
		$this->error->complete('index.php', $this->lang->language['logout_done'].$this->user_info['user_nick']);
		exit;

	}

	/**
    * Check if the visitor is a spider
    *
    * @param String $userAgent
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */	
	function is_spider($userAgent)
	{
		$f=fopen('inc/spiders.txt','r');
		$content=fread($f,filesize('inc/spiders.txt'));
		$array=explode('|',$content);
		$num=count($array);
		for($i=0;$i<$num;$i++)
		{
			$temp=explode('=',$array[$i]);

			if(eregi($temp[0], $userAgent))
				return $temp[1];
		}
		return ''; 
	}
	
  /**
    * Check if a 3d is visited
    * @param int tid
    * @author dierre <dierre@gmail.com> 
    * since v 1.0
    * @access Public
    * @return bool
    */
  function has_visited($tid, $page, $add=1)
  {
	   
	   //init of visited session
		if(!isset($_SESSION['visited'.$page]))
		{ 
			if($add==1)
				$_SESSION['visited'.$page] = $tid;
			return false; 
		}
		
		// check for $tid visited
		$visited = explode(",",$_SESSION['visited'.$page]);
		foreach($visited as $visit)
			if($visit==$tid)
				return true;
		
		//if is not visited update the visited session
		if($add==1)
			$_SESSION['visited'.$page] = $_SESSION['visited'.$page].",".$tid;
		return false;
		
		
   }  
     
  /**
    * Upload the sign
    * @param String $text
    * @author denadai2 <denadai2@gmail.com> 
    * since v 1.0
    * @access Public
    * @return none
    */
	function update_sign($text)
	{
		require 'inc/class_thread.php';
		
   		$thread = new Thread($this->classes);
		
		$text=nl2br($text);
		$text = $thread->parse_text($text);
		$text = $thread->prepare_post($text);
		
		$this->db->execQuery($this->db->sql_build('update_user_sign', array( $text, $this->info_user['user_id'] ) ));
	}     
	
  /**
    * Update avatar
    * @param String $text
    * @author denadai2 <denadai2@gmail.com> 
    * since v 1.0
    * @access Public
    * @return none
    */
	function update_avatar($mode)
	{
		switch($mode)
		{
		case 1:{
				require 'inc/class_uploads.php';
				
				if (!is_uploaded_file($_FILES['image']['tmp_name']))
					$this->error->simple_error('error_upload');
				//$upload = new File_Upload($this->classes);
				$upfile = 'uploads/avatars/'.$_FILES['avatar']['name'];
									
				if(!copy($_FILES['avatar']['tmp_name'], $upfile))
					$this->error->simple_error('upload_temp');
							
				$this->process_avatar($upfile, $this->info_user['user_id']);
				
				}break;
		case 2:{
				require 'inc/class_gd_ver.php';
				
				$gd = new gd_handler();
				
				if(strlen($_POST['url'])<10 || !strstr($_POST['url'],'http://'))	
					$this->error->simple_error('invalid_url');
				
				$image = $gd->http_get_file($_POST['url'], $this->error);
				
				$upfile = 'uploads/avatars/'.$id.'_temp.jpg';
				
				$f=fopen($upfile, 'w');
				
				fwrite($f, $image);
				
				fclose($f);
				
				$this->process_avatar($upfile, $this->info_user['user_id']);
				
				}break;
		case 3:{
				
				$this->db->execQuery($this->db->sql_build('update_user_avatar', array( 'noavatar.gif', $this->info_user['user_id'] ) ));
				
				}break;
		
		}
	} 
	
  /**
    * Upload an avatar
    * @param String $upfile
	* @param int $id
    * @author denadai2 <denadai2@gmail.com> 
    * since v 1.0
    * @access Public
    * @return none
    */
	function process_avatar($upfile, $id)
	{
		
		$max_width = 100;
		$max_height = 100;
		list($width, $height, $type, $attr) = getimagesize($upfile);
	
		// Proportionally resize
         $x_ratio = $max_width / $width;
         $y_ratio = $max_height / $height;

         if( ($width <= $max_width) && ($height <= $max_height) )
         {
               $tn_width = $width;
               $tn_height = $height;
         }
         elseif (($x_ratio * $height) < $max_height)
         {
               $tn_height = ceil($x_ratio * $height);
               $tn_width = $max_width;
         }
         else
         {
               $tn_width = ceil($y_ratio * $width);
               $tn_height = $max_height;
         }
		
		
		switch($type)
		{
			case 1: $src = imagecreatefromgif($upfile); $type='gif'; break;
			case 2: $src = imagecreatefromjpeg($upfile); $type='jpg'; break;
			case 3: $src = imagecreatefrompng($upfile); $type='png'; break;
			default: unlink($upfile); $this->error->simple_error('invalid_image'); break;
		}
		
		$filename='uploads/avatars/'.$id.'.jpg';
		
		if(file_exists($filename))
			unlink($filename);
			
     	$dst = imagecreatetruecolor($tn_width, $tn_height);
		imagecopyresized($dst, $src, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);
		
		imagejpeg($dst,$filename,100);
		
		$this->db->execQuery($this->db->sql_build('update_user_avatar', array( $id.'.jpg', $id ) ));
		
		unlink($upfile);
	}
	
	function send_activation_email($id=0)
	{
		if($id!=0)
			$this->info_user = $this->get_infos($id);
		$headers = "From: ".$this->_config['admin_email']."\n";
		$headers .= "Return-Path: ".$this->_config['admin_email']."\n";
		@mail( $this->info_user['user_email'] , $this->lang->lang_all['register']['main']['activate_email'], $this->lang->lang_all['register']['main']['dear'] . $this->info_user['user_nick'] ."\n\n" . $this->lang->lang_all['register']['main']['activate'] . $this->_config['board_domain'].$this->_config['board_url'].'index.php?act=usercp&code=14&h='.$this->info_user['user_password'].'&s='.base64_encode($this->info_user['joined']), $headers );
		
		if($id!=0)
			$this->info_user = $this->get_infos(-1);
	
	}
	
	function activate_user($hash, $stamp)
	{
		$query = $this->db->execQuery( $this->db->sql_build('fetch_activation', array($hash, base64_decode($stamp) ) ) );
		
		if($this->db->num_rows($query)!=1)
			$this->error->simple_error('no_active');
			
		$query = $this->db->execQuery( $this->db->sql_build('update_ustatus', array($hash, base64_decode($stamp) ) ) );
	}
	
}
?>