<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

	
function generate_pagination($base_url, $num_items, $per_page, $start_item)
{

	$total_pages = ceil($num_items/$per_page);

	if ( $total_pages <= 1 )
	{
		return '<strong>1</strong>';
	}

	$on_page = floor($start_item / $per_page) + 1;

	$page_string = '';
	if ( $total_pages > 10 )
	{
		$init_page_max = ( $total_pages > 3 ) ? 3 : $total_pages;

		for($i = 1; $i < $init_page_max + 1; $i++)
		{
			$page_string .= ( $i == $on_page ) ? '<strong>'.$i.'</strong>' : '&nbsp;<a href="' .$base_url . ( ( $i - 1 ) * $per_page ) . '" class="forumlink">' . $i . '</a>';
			
		}

		if ( $total_pages > 3 )
		{
			if ( $on_page > 1  && $on_page < $total_pages )
			{
				$page_string .= ( $on_page > 5 ) ? ' ... ' : ', ';

				$init_page_min = ( $on_page > 4 ) ? $on_page : 5;
				$init_page_max = ( $on_page < $total_pages - 4 ) ? $on_page : $total_pages - 4;

				for($i = $init_page_min - 1; $i < $init_page_max + 2; $i++)
				{
					$page_string .= ($i == $on_page) ? '<strong>'.$i.'</strong>' : '&nbsp;<a href="'.$base_url . ( ( $i - 1 ) * $per_page ).'" class="forumlink">'.$i.'</a>';
					
				}

				$page_string .= ( $on_page < $total_pages - 4 ) ? ' ... ' : ', ';
			}
			else
			{
				$page_string .= ' ... ';
			}

			for($i = $total_pages - 2; $i < $total_pages + 1; $i++)
			{
				$page_string .= ( $i == $on_page ) ? '<strong>'.$i.'</strong>' : '&nbsp;<a href="'.$base_url . ( ( $i - 1 ) * $per_page ).'" class="forumlink">'.$i.'</a>';
				
			}
		}
	}
	else
	{
		for($i = 1; $i < $total_pages + 1; $i++)
		{
			$page_string .= ( $i == $on_page ) ? '<strong>'.$i.'</strong>' : '&nbsp;<a href="'.$base_url . ( ( $i - 1 ) * $per_page ).'" class="forumlink">'.$i.'</a>';
			
		}
	}



	return $page_string;
}	

/**
* create a menu
*
* @param string $nom
* @param int $val
* @param int $tab
* @param int $stes
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return String
*/	
function menu_create($nom, $val, $tab = '0', $stes = '0')
{
	$men = "<select name='".$nom."'>";
	$count = 0;
	foreach($val as $key => $str)
	{
		if($count == $tab)
			$sel = " selected='selected' ";
		else
			$sel = "";
			
		if($stes == '1')
			$men .= "<option value = '{$str}'{$sel}>{$str}</option>";
		else
			$men .= "<option value = '{$key}'{$sel}>{$str}</option>";
		
		$count++;
	}
	
	$men .= "</select>";
	return $men;
}

/**
* compile a insert mysql string
*
* @param array $data
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return Array
*/	

function compile_insert($data) {
    
    	$field_names  = "";
		$field_values = "";
		
		foreach ($data as $k => $v)
		{
			$v = preg_replace( "/'/", "\\'", $v );
			
			$field_names  .= "$k,";
			$field_values .= "'$v',";
		}
		
		$field_names  = preg_replace( "/,$/" , "" , $field_names  );
		$field_values = preg_replace( "/,$/" , "" , $field_values );
		
		return array( 'NOME'  => $field_names,
					  'VAL'   => $field_values,
					);
	}

/**
* compile an update mysql string
*
* @param array $data
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return String
*/
	
	function compile_update($data) {
		
		$return_string = "";
		
		foreach ($data as $k => $v)
		{
			$v = preg_replace( "/'/", "\\'", $v );
			$return_string .= $k . "='".$v."',";
		}
		
		$return_string = preg_replace( "/,$/" , "" , $return_string );
		
		return $return_string;
	}
?>