<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     outputfilter.tidyrepairhtml.php
 * Type:     outputfilter
 * Name:     tidyrepairhtml
 * Version:  1.0
 * Date:     Sept. 20, 2003
 * Purpose:  Uses the tidy extension to repair a mailformed HTML
 *           template before displaying it
 * Install:  Drop into the plugin directory, call 
 *           $smarty->load_filter('output','tidyrepairhtml');
 *           from application.
 * Author:   John Coggeshall <john@php.net>
 * -------------------------------------------------------------
 */
 function template_outputfilter_tidyrepairhtml ($html, &$smarty)
 {
 
 if( class_exists('tidy'))
	{
		// Specify configuration
		$config = array(
				   'indent'        => true,
				   'output-xhtml'  => true,
				   'wrap'          => 200,
				   'indent-spaces'	=>	2,
				   'wrap'			=>	200);
		
		// Tidy
		$tidy = new tidy;
		$tidy->parseString($html, $config);
		$tidy->cleanRepair();
		
		// Output
		return $tidy;
	}
	else
	if( function_exists( 'tidy_parse_string' ) ) 
		{
	
		tidy_parse_string($html);
		tidy_setopt('alt-text', '');
		tidy_setopt('output-xhtml', TRUE);
		tidy_setopt('indent', TRUE);
		tidy_setopt('indent-spaces', 2);
		tidy_setopt('wrap', 200);
		tidy_clean_repair();
		  
		$tidyhtml= tidy_get_output();
		
		return $tidyhtml;
		}
	else
		return $html;
	
   /* if(extension_loaded('tidy')) {
        tidy_parse_string($source);
        tidy_clean_repair();
        return  tidy_get_output();
    } 
    return $source; */
 }

?>